#include "StdAfx.h"
#include "trackset.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//		unsigned	int		_id			BGMԍ
//		bool				_sub		̃IuWFNǵATu[`H
//		const		wchar_t	_strName[]	IuWFNg
//	Ԓl
//					
//==============================================================
TrackSet::TrackSet(MMLfile* MML, unsigned int _id, bool _sub, bool _se, const wchar_t _strName[]):
	MusicItem(_strName),
	iTempo(120),
	m_id(_id)
{
	//----------------------
	//Localϐ

//	萔`
enum	Command_ID_mml {
	mml_Track,
	mml_Scale,
	mml_Major,
	mml_Minor,
	mml_HMinor,
	mml_MMinor,
	mml_KeySignature,
	mml_Macro,
	mml_CallSE,
	mml_Subroutine,

	mml_Loop,
	mml_Repeat_A_Start,
	mml_Repeat_A_Branch,
	mml_Repeat_A_End,
	mml_Repeat_B_Start,
	mml_Repeat_B_Branch,
	mml_Repeat_B_End,

	mml_Tempo,
	mml_Tempo_Relative,
	mml_Tempo_Up,
	mml_Tempo_Down,

	mml_La,
	mml_Si,
	mml_Do,
	mml_Re,
	mml_Mi,
	mml_Fa,
	mml_Sol,
	mml_Rest,
	mml_Wait,
	mml_Tai,

	mml_Length,
	mml_Gate_Q,
	mml_Gate_q,
	mml_Gate_u,

	mml_Echo,
	mml_Echo_Off,
	mml_Echo_Reset,

	mml_Jump,

	mml_Envelop_Voice,
	mml_Envelop_Volume,
	mml_Envelop_Frequency,
	mml_Envelop_Note,

	mml_Envelop_Off_Voice,
	mml_Envelop_Off_Volume,
	mml_Envelop_Off_Frequency,
	mml_Envelop_Off_Note,

	mml_Release_mdoe,
	mml_Release_Voice,
	mml_Release_Volume,

	mml_FDSC,
	mml_FDSM,
	mml_FDSF,
	mml_FDSV,
	mml_VRC7,
	mml_N163,
	mml_Voice,
	mml_N163_Channel,
	mml_FME7_frequency,

	mml_Octave,
	mml_Octave_Up,
	mml_Octave_Down,
	mml_Octave_Up1,
	mml_Octave_Down1,
	mml_Detune_Cent,
	mml_Detune_Register,
	mml_Transpose,
	mml_Transpose_Relative,
	mml_KeyShift,
	mml_KeyShift_Relative,
	mml_Protament,
	mml_Protament2,
	mml_Sweep,

	mml_Volume,
	mml_Volume_Up,
	mml_Volume_Down,

	mml_VRC7_Write,
	mml_Memory_Write,

	mml_Priority,

	mml_Bar
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"TR",		mml_Track				},
		{	"gbN",	mml_Track				},
		{	"Scale",	mml_Scale				},
		{	"scale",	mml_Scale				},
		{	"Mode",		mml_Scale				},
		{	"mode",		mml_Scale				},
		{	"Major",	mml_Major				},
		{	"major",	mml_Major				},
		{	"Minor",	mml_Minor				},
		{	"minor",	mml_Minor				},
		{	"HMinor",	mml_HMinor				},
		{	"hminor",	mml_HMinor				},
		{	"MMinor",	mml_MMinor				},
		{	"mminor",	mml_MMinor				},

		{	"K",		mml_KeySignature		},
		{	"",		mml_KeySignature		},
		{	"SE",		mml_CallSE				},
		{	"S",		mml_Subroutine			},
		{	"$",		mml_Macro				},

		{	"L",		mml_Loop				},
		{	"|:",		mml_Repeat_B_Start		},
		{	"\\",		mml_Repeat_B_Branch		},
		{	":|",		mml_Repeat_B_End		},
		{	"[",		mml_Repeat_A_Start		},
		{	":",		mml_Repeat_A_Branch		},
		{	"]",		mml_Repeat_A_End		},

		{	"",		mml_Loop				},
		{	"bF",		mml_Repeat_B_Start		},
		{	"",		mml_Repeat_B_Branch		},
		{	"Fb",		mml_Repeat_B_End		},
		{	"y",		mml_Repeat_A_Start		},
		{	"F",		mml_Repeat_A_Branch		},
		{	"z",		mml_Repeat_A_End		},

		{	"t_",		mml_Tempo_Relative,		},
		{	"t",		mml_Tempo,				},
		{	"e|",	mml_Tempo,				},
		{	"",		mml_Tempo_Up,			},
		{	"",		mml_Tempo_Down,			},

		{	"a",	mml_La					},
		{	"b",	mml_Si					},
		{	"c",	mml_Do					},
		{	"d",	mml_Re					},
		{	"e",	mml_Mi					},
		{	"f",	mml_Fa					},
		{	"g",	mml_Sol					},
		{	"r",	mml_Rest				},
		{	"w",	mml_Wait				},
		{	"^",	mml_Tai					},

		{	"",	mml_La					},
		{	"",	mml_Si					},
		{	"",	mml_Do					},
		{	"",	mml_Re					},
		{	"",	mml_Mi					},
		{	"ӂ",	mml_Fa					},
		{	"",	mml_Fa					},
		{	"",	mml_Sol					},
		{	"",	mml_Rest				},
		{	"",	mml_Rest				},
		{	"[",	mml_Tai					},

		{	"",	mml_La					},
		{	"V",	mml_Si					},
		{	"h",	mml_Do					},
		{	"",	mml_Re					},
		{	"~",	mml_Mi					},
		{	"t@",	mml_Fa					},
		{	"t",	mml_Fa					},
		{	"\",	mml_Sol					},
		{	"",	mml_Rest				},
		{	"b",	mml_Rest				},
		{	"|",	mml_Tai					},

		{	"C",	mml_La					},
		{	"",	mml_Si					},
		{	"n",	mml_Do					},
		{	"j",	mml_Re					},
		{	"z",	mml_Mi					},
		{	"w",	mml_Fa					},
		{	"g",	mml_Sol					},

		{	"l",		mml_Length				},
		{	"",		mml_Length				},
		{	"Q",		mml_Gate_Q				},
		{	"q",		mml_Gate_q				},
		{	"Q[g",	mml_Gate_q				},
		{	"u",		mml_Gate_u				},

		{	"EC-",			mml_Echo_Reset			},
		{	"EC*",			mml_Echo_Off			},
		{	"EC",			mml_Echo				},
		{	"GR[It",	mml_Echo_Off			},
		{	"GR[",		mml_Echo				},

		{	"J",			mml_Jump				},

		{	"E@*",	mml_Envelop_Off_Voice		},
		{	"Ev*",	mml_Envelop_Off_Volume		},
		{	"Em*",	mml_Envelop_Off_Frequency	},
		{	"En*",	mml_Envelop_Off_Note		},

		{	"E@",	mml_Envelop_Voice		},
		{	"Ev",	mml_Envelop_Volume		},
		{	"Em",	mml_Envelop_Frequency	},
		{	"En",	mml_Envelop_Note		},

		{	"Gx[vIt",	mml_Envelop_Off_Volume		},
		{	"Gx[v",		mml_Envelop_Volume			},
		{	"ru[gIt",	mml_Envelop_Off_Frequency	},
		{	"ru[g",		mml_Envelop_Frequency		},

		{	"Rm",	mml_Release_mdoe		},
		{	"R@",	mml_Release_Voice		},
		{	"Rv",	mml_Release_Volume		},

		{	"@FC",	mml_FDSC				},
		{	"@FM",	mml_FDSM				},
		{	"@FF",	mml_FDSF				},
		{	"@FV",	mml_FDSV				},
		{	"@V",	mml_VRC7				},
		{	"@N",	mml_N163				},
		{	"@",	mml_Voice				},
		{	"F",	mml_Voice				},
		{	"NC",	mml_N163_Channel		},
		{	"F",	mml_FME7_frequency		},

		{	"o",	mml_Octave				},
		{	"K",	mml_Octave				},
		{	">",	mml_Octave_Up			},
		{	"",	mml_Octave_Up			},
		{	"",	mml_Octave_Up			},
		{	"<",	mml_Octave_Down			},
		{	"",	mml_Octave_Down			},
		{	"",	mml_Octave_Down			},
		{	"`",	mml_Octave_Up1			},
		{	"e",	mml_Octave_Up1			},
		{	"\"",	mml_Octave_Down1		},
		{	"h",	mml_Octave_Down1		},

		{	"D%",			mml_Detune_Register		},
		{	"D",			mml_Detune_Cent			},
		{	"fB`[",	mml_Detune_Cent			},
		{	"__",			mml_Transpose_Relative	},
		{	"_",			mml_Transpose			},
		{	"k_",			mml_KeyShift_Relative	},
		{	"k",			mml_KeyShift			},
		{	"TrackKey",		mml_Transpose			},
		{	"P",			mml_Protament			},
		{	"|^g",	mml_Protament			},
		{	"{",			mml_Protament2			},
		{	"s",			mml_Sweep				},

		{	"v",		mml_Volume				},
		{	"",		mml_Volume				},
		{	")",		mml_Volume_Up			},
		{	"傫",	mml_Volume_Up			},
		{	"",		mml_Volume_Up			},
		{	"(",		mml_Volume_Down			},
		{	"",	mml_Volume_Down			},
		{	"",		mml_Volume_Down			},

		{	"yV",	mml_VRC7_Write			},
		{	"y",	mml_Memory_Write		},

		{	"#Priority",	mml_Priority	},
		{	"#priority",	mml_Priority	},

		{	"@",	mml_Bar					},
		{	"|",	mml_Bar					},
		{	"b",	mml_Bar					}
};

	unsigned	char	cData;
				int		i;

	//------------------------------
	//NX̏ݒ
	fSub		= _sub;		//Tu[`̃tO
	fSE			= _se;		//
	iTrack		= 0;		//RpC̃gbNiDefault = 0j
	maxTrack	= 0;		//őgbNԍ

	if(fSE == true){
		Priority	= MML->priority;
	} else {
		Priority	= 0;
	}

	//܂́APgbNi0ԁj̃IuWFNgB
	nowTrack	= makeTrack(MML, iTrack);
	nowTrack->SetCompileFlag(true);


	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err(L"ubN̊Jn{܂B");
		}
	}

	// } ܂ŁALqubNRpCB
	while(1){

		cData = MML->GetChar();
		if(cData == '}'){
			TrackChk(MML);
			if(nowTrack == NULL){
				break;
			}
		} else {
			// } OɁA[EOF]G[
			if( MML->eof() ){
				MML->Err(L"ubN̏I[`}'܂B");
			}

			//P߂
			MML->Back();
		}

		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(mml_Track):
				if(fSub == true){
					MML->Warning(L"SububNł̓gbNw͂ł܂B܂B");
				} else {
					TrackProc(MML);
				}
				break;

			case(mml_Scale):
				nowTrack->SetScale(MML);
				break;

			case(mml_Major):
				nowTrack->SetMajor();
				break;

			case(mml_Minor):
				nowTrack->SetMinor();
				break;

			case(mml_HMinor):
				nowTrack->SetHMinor(MML);
				break;

			case(mml_MMinor):
				nowTrack->SetMMinor(MML);
				break;

			case(mml_KeySignature):
				nowTrack->SetKeySignature(MML);
				break;

			case(mml_Macro):
				MML->CallMacro();
				break;

			case(mml_CallSE):
				nowTrack->SetSE(MML);
				break;

			case(mml_Subroutine):
				nowTrack->SetSubroutine(MML);
				break;

			case(mml_Loop):
				if(fSub == true){
					MML->Warning(L"SububNł͖[v͂ł܂B܂B");
				} else {
					nowTrack->SetLoop();
				}
				break;

			case(mml_Repeat_A_Start):
				nowTrack->SetRepeat_A_Start(MML);
				break;

			case(mml_Repeat_A_Branch):
				nowTrack->SetRepeat_A_Branch(MML);
				break;

			case(mml_Repeat_A_End):
				nowTrack->SetRepeat_A_End(MML);
				break;

			case(mml_Repeat_B_Start):
				nowTrack->SetRepeat_B_Start();
				break;

			case(mml_Repeat_B_Branch):
				nowTrack->SetRepeat_B_Branch(MML);
				break;

			case(mml_Repeat_B_End):
				nowTrack->SetRepeat_B_End(MML);
				break;

			case(mml_Tempo):
				SetTempo(MML);
				break;

			case(mml_Tempo_Relative):
				SetRelativeTempo(MML);
				break;

			case(mml_Tempo_Up):
				SetRelativeUp();
				break;

			case(mml_Tempo_Down):
				SetRelativeDown();
				break;

			case(mml_La):
				nowTrack->SetNote(MML, 5);
				break;

			case(mml_Si):
				nowTrack->SetNote(MML, 6);
				break;

			case(mml_Do):
				nowTrack->SetNote(MML, 0);
				break;

			case(mml_Re):
				nowTrack->SetNote(MML, 1);
				break;

			case(mml_Mi):
				nowTrack->SetNote(MML, 2);
				break;

			case(mml_Fa):
				nowTrack->SetNote(MML, 3);
				break;

			case(mml_Sol):
				nowTrack->SetNote(MML, 4);
				break;

			case(mml_Rest):
				nowTrack->SetRest(MML, MML->rest);
				break;

			case(mml_Wait):
				nowTrack->SetRest(MML, MML->wait | 0x80);
				break;

			case(mml_Tai):
				nowTrack->SetTai(MML);
				break;

			case(mml_Length):
				nowTrack->SetLength(MML);
				break;

			case(mml_Gate_Q):
				nowTrack->SetGatetime_Q(MML);
				break;

			case(mml_Gate_q):
				nowTrack->SetGatetime(MML);
				break;

			case(mml_Gate_u):
				nowTrack->SetGatetime_u(MML);
				break;

			case(mml_Echo_Reset):
				nowTrack->ResetEcho();
				break;

			case(mml_Echo_Off):
				nowTrack->SetEcho();
				break;

			case(mml_Echo):
				nowTrack->SetEcho(MML);
				break;

			case(mml_Jump):
				nowTrack->SetJump(MML);
				break;

			case(mml_Envelop_Voice):
				nowTrack->SetEnvelop(nsd_Envelop_Voice, MML, MML->offset_Ei);
				break;

			case(mml_Envelop_Volume):
				nowTrack->SetEnvelop(nsd_Envelop_Volume, MML, MML->offset_Ev);
				break;

			case(mml_Envelop_Frequency):
				nowTrack->SetEnvelop(nsd_Envelop_Frequency, MML, MML->offset_Em);
				break;

			case(mml_Envelop_Note):
				nowTrack->SetEnvelop(nsd_Envelop_Note, MML, MML->offset_En);
				break;

			case(mml_Envelop_Off_Voice):
				MML->Err(L"FGx[v́A@R}hŖɂł܂B");
				break;

			case(mml_Envelop_Off_Volume):
				SetEvent(new mml_Address(nsd_Envelop_Volume));
				break;

			case(mml_Envelop_Off_Frequency):
				SetEvent(new mml_Address(nsd_Envelop_Frequency));
				break;

			case(mml_Envelop_Off_Note):
				SetEvent(new mml_Address(nsd_Envelop_Note));
				break;

			case(mml_Release_mdoe):
				SetReleaseMode(MML);
				break;

			case(mml_Release_Voice):
				SetReleaseVoice(MML);
				break;

			case(mml_Release_Volume):
				SetReleaseVolume(MML);
				break;

			case(mml_Voice):
				SetEvent(new mml_general(nsd_Voice, MML, L"Voice"));
				break;

			case(mml_FDSC):
				nowTrack->SetFDSC(MML);
				break;

			case(mml_FDSM):
				nowTrack->SetFDSM(MML);
				break;

			case(mml_FDSF):
				Set_FDS_Frequency(MML);
				break;

			case(mml_FDSV):
				Set_FDS_Volume(MML);
				break;

			case(mml_VRC7):
				nowTrack->SetVRC7(MML);
				break;

			case(mml_N163):
				nowTrack->SetN163(MML);
				break;

			case(mml_N163_Channel):
				SetN163Channel(MML);
				break;

			case(mml_FME7_frequency):
				Set_FME7_Frequency(MML);
				break;

			case(mml_Octave):
				nowTrack->SetOctave(MML);
				break;

			case(mml_Octave_Up):
				if(MML->octave_reverse == true){
					nowTrack->SetOctaveDec();
				} else {
					nowTrack->SetOctaveInc();
				}
				break;

			case(mml_Octave_Down):
				if(MML->octave_reverse == true){
					nowTrack->SetOctaveInc();
				} else {
					nowTrack->SetOctaveDec();
				}
				break;

			case(mml_Octave_Up1):
				nowTrack->SetOctaveOne_Inc();
				break;

			case(mml_Octave_Down1):
				nowTrack->SetOctaveOne_Dec();
				break;

			case(mml_Detune_Cent):
				SetEvent(new mml_general(nsd_Detune_Cent, MML, L"Detune Cent"));
				break;

			case(mml_Detune_Register):
				SetEvent(new mml_general(nsd_Derune_Register, MML, L"Derune Register"));
				break;

			case(mml_Transpose):
				SetEvent(new mml_general(nsd_Transpose, MML, L"Transpose"));
				break;

			case(mml_Transpose_Relative):
				SetEvent(new mml_general(nsd_Relative_Transpose, MML, L"Relative Transpose"));
				break;

			case(mml_KeyShift):
				nowTrack->SetKeyShift(MML);
				break;

			case(mml_KeyShift_Relative):
				nowTrack->SetKeyShift_Relative(MML);
				break;

			case(mml_Protament):
				nowTrack->SetProtament(MML);
				break;

			case(mml_Protament2):
				nowTrack->SetProtament(MML, iTempo);
				break;

			case(mml_Sweep):
				SetSweep(MML);
				break;

			case(mml_Volume):
				SetVolume(MML);
				break;

			case(mml_Volume_Up):
				SetVolumeInc(MML);
				break;

			case(mml_Volume_Down):
				SetVolumeDec(MML);
				break;

			case(mml_VRC7_Write):
				SetVRC7_Write(MML);
				break;

			case(mml_Memory_Write):
				SetPoke(MML);
				break;

			case(mml_Priority):
				SetPriority(MML);
				break;

			case(mml_Bar):
				break;

			//unknown command
			default:
				MML->Err(L"unknown command");
				break;
		}
	}

	if(fSub == true){
		//Tu[`ubN̏ꍇ
		code.resize(0);
		i = (int)ptcTrack[iTrack]->SetEnd();

	} else {
		//ȊȌꍇ
		i = 2 + ((maxTrack + 1) * 2);		//gbNwb_[̃TCYvZB
		code.resize(i);						//wb_pɃR[hTCYm

		code[0] = (unsigned char)maxTrack + 1;				//gbN
		code[1] = Priority;									//etO

		//egbNɏI[āAȃf[^̃AhX쐬
		iTrack = 0;
		while(iTrack <= maxTrack){
			code[iTrack *2 + 2]	= (unsigned char)((i   ) & 0xFF);
			code[iTrack *2 + 3]	= (unsigned char)((i>>8) & 0xFF);
			i += (int)ptcTrack[iTrack]->SetEnd();
			iTrack++;
		}
	}
	iSize = i;

}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
TrackSet::~TrackSet(void)
{
}

//==============================================================
//		JEg
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	TrackSet::TickCount(MusicFile* MUS)
{
	int		i		= 0;
	int		iTick;

	cout	<< "Track ";
	while(i<=maxTrack){
		i++;
		cout << "| TR(" << setfill(' ')  << setw(2) << i << ") ";
	}
	cout << endl <<	"Loop  ";

	i=0;
	while(i<=maxTrack){
		ptcTrack[i]->TickCount(MUS, 24);
		iTick = ptcTrack[i]->GetTickLoop();
		if(iTick == -1){
			cout << "| no-loop";
		} else {
			cout << "|" << setw(8) << setfill(' ') << iTick;
		}
		i++;
	}
	cout << endl <<	"Total ";;

	i=0;
	while(i<=maxTrack){
		cout << "|" << setw(8) << setfill(' ') << ptcTrack[i]->GetTickTotal();
		i++;
	}
	cout << endl;
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::getAsm(MusicFile* MUS)
{
	//----------------------
	//Localϐ
	int	i = 0;
	vector<	MusicItem*>::iterator	itItem;

	if(fSub == false){
		*MUS << "	.byte	$" << hex << setw(2) << setfill('0') << (int)(code[0] & 0xFF) << ", $" << (int)(code[1] & 0xFF) << endl;
		while(i <= maxTrack){
			if(i==0){
				*MUS << "	.word	$";
			} else {
				*MUS << " ,$";
			}
			*MUS << hex << setw(4) << setfill('0') << (int)((code[i*2+2] & 0xFF) | ((code[i*2+3] & 0xFF)<<8));
			i++;
		}
		*MUS << dec << endl;
	}

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			(*itItem)->getAsm(MUS);
			itItem++;
		}
	}
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::Fix_Address(MusicFile* MUS)
{
	iTrack = 0;
	while(iTrack <= maxTrack){
		ptcTrack[iTrack]->Fix_Address(MUS);
		iTrack++;
	}

}

//==============================================================
//		gbN
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::TrackChk(MMLfile* MML)
{
	int		i = iTrack + 1;

	if(MML->GetMacroNest() > 0){
		MML->Err(L"}NŃgbN̎w͂ł܂B");
	}

	//------------------
	//̃gbÑ`FbN
//	i		= iTrack + 1;
	iTrack	= 0;
	while(i <= maxTrack){
		if(ptcTrack[i]->GetCompileFlag() == true){
			iTrack = i;
			break;
		}
		i++;
	}

	if(iTrack != 0){
		//------------------
		//̃gbNꍇ

		//|C^ƍsԍ𕜋A
		MML->StreamPointerMove(TrackPt);
		MML->SetLine(TrackLine);
		nowTrack = getTrack(MML, iTrack);
	} else {
		nowTrack = NULL;
	}
}

//==============================================================
//		gbN̏
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::TrackProc(MMLfile* MML)
{
					int		i;
	unsigned		char	cData;

	//------------------
	//̃gbÑ`FbN

	TrackChk(MML);

	if(nowTrack == NULL){
		//------------------
		//̃gbNȂꍇ

		//tOSăZbg
		i = 0;
		while(i <= maxTrack){
			ptcTrack[i]->SetCompileFlag(false);
			i++;
		}
		
		//RpCgbN
		do{
			iTrack = MML->GetInt() - 1;
			if( (iTrack <= -1) ){
				MML->Err(L"gbNԍŎwł͈͂𒴂Ă܂B");
			}
			nowTrack = getTrack(MML, iTrack);
			nowTrack->SetCompileFlag(true);
			cData = MML->GetChar();
		} while(cData == ',');
		MML->Back();

		//|C^ƍsԍޔ
		TrackPt		= MML->tellg();
		TrackLine	= MML->GetLine();

		//ŏ
		i = 0;
		while(i <= maxTrack){
			if(ptcTrack[i]->GetCompileFlag() == true){
				iTrack = i;
				nowTrack = getTrack(MML, iTrack);
				break;
			}
			i++;
		}

	}

}

//==============================================================
//		gbN̍쐬
//--------------------------------------------------------------
//	
//		unsigned	int	_track		gbNԍ
//	Ԓl
//		MusicTrack*					gbNEIuWFNg̃|C^
//==============================================================
MusicTrack*	TrackSet::makeTrack(MMLfile* MML, int _track)
{
	//gbÑIuWFNg𐶐B
	MusicTrack*	newTrack	= new MusicTrack(MML);

	//ACe͕ۑ
	ptcItem.push_back(newTrack);		//NX"MusicItem"ŊJB
	ptcTrack[_track] = newTrack;

	//|C^n
	return(newTrack);
}

//==============================================================
//		gbNEIuWFNg̃|C^擾
//--------------------------------------------------------------
//	
//		unsigned	int	_track	gbNԍ
//	Ԓl
//		MusicTrack*				gbNEIuWFNg̃|C^
//	Ԓl
//		w肳ꂽԍ̃gbNEIuWFNg̃|C^擾
//		ꍇ͐VɃgbNāA
//		gbNԍől𒴂ĂőlXVB
//==============================================================
MusicTrack*	TrackSet::getTrack(MMLfile* MML, int _track)
{
			int	i			 = maxTrack;	// i = AŏIgbN̔ԍ
	MusicTrack*	_getTrack;

	//ŏIgbNԍwlAJԂB
	while(i < _track){
		i++;
		//gbN
		if(ptcTrack.count(i) == 0){
			_getTrack	= makeTrack(MML, i);
		} else {
			wcerr << L"MusicTrack* TrackSet::getTrack()֐ŃG[܂B" << endl;
			exit(-1);
		}
	}
	maxTrack = i;	//gbN̍őlLB

	//|C^擾B
	_getTrack = ptcTrack[_track];

	return(_getTrack);
}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MusicItem* _item
//	Ԓl
//		
//==============================================================
void	TrackSet::SetEvent(MusicItem* _item)
{
	nowTrack->SetEvent(_item);
}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetTempo(MMLfile* MML)
{
	int	iValue	= MML->GetInt();

	iTempo = (char)((iValue * MML->timebase) / 24);
	
	if((iValue<0) || (iValue>255)){
		MML->Err(L"e|w\Ȕ͈͂𒴂܂B");
	}
	SetEvent(new mml_general(nsd_Tempo, (unsigned char)iTempo, L"Tempo"));
}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetRelativeTempo(MMLfile* MML)
{
	int	iValue	= MML->GetInt();

	iTempo += iValue;

	SetEvent(new mml_general(nsd_Relative_Tempo, (char)iValue, L"Relative Tempo"));

}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetRelativeUp()
{
	iTempo += 4;

	SetEvent(new mml_general(nsd_Relative_Tempo, (char)4, L"Relative Tempo"));

}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetRelativeDown()
{
	iTempo -= 4;

	SetEvent(new mml_general(nsd_Relative_Tempo, (char)-4, L"Relative Tempo"));

}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetVolume(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 15) && (i >= 0) ){
		if(nowTrack->Get_opt_volume() != i){
			SetEvent(new mml_general(nsd_Volume + (unsigned char)i, L"Volume"));
			nowTrack->SetVolume((unsigned char)i);
		}
	} else {
		MML->Err(L"ʂ0`15͈̔͂Ŏw肵ĂB");
	}
}

//------
void	TrackSet::SetVolumeInc(MMLfile* MML)
{
	unsigned	char	cData = MML->GetChar();
	unsigned	int		iValue;

	if((cData >= '0') && (cData <= '9')){
		MML->Back();
		iValue = MML->GetInt();
	} else {
		MML->Back();
		iValue = 1;
	}

	while(iValue > 0){
		SetEvent(new mml_general(nsd_Volume_Up, L"Volume up"));
		nowTrack->IncVolume();
		iValue--;
	}
}

//------
void	TrackSet::SetVolumeDec(MMLfile* MML)
{
	unsigned	char	cData = MML->GetChar();
	unsigned	int		iValue;

	if((cData >= '0') && (cData <= '9')){
		MML->Back();
		iValue = MML->GetInt();
	} else {
		MML->Back();
		iValue = 1;
	}

	while(iValue > 0){
		SetEvent(new mml_general(nsd_Volume_Down, L"Volume down"));
		nowTrack->DecVolume();
		iValue--;
	}
}

//==============================================================
//		[X[h
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetReleaseMode(MMLfile* MML)
{
	mml_general*	_event;
	unsigned	int	i = MML->GetInt();

	switch(i){
		case(0):
			_event = new mml_general(nsd_GateMode_0,  L"GateMode 0");
			break;
		case(1):
			_event = new mml_general(nsd_GateMode_1,  L"GateMode 1");
			break;
		case(2):
			_event = new mml_general(nsd_GateMode_2,  L"GateMode 2");
			break;
		default:
			MML->Err(L"[X[h0`2͈̔͂Ŏw肵ĂB");
			break;
	}
	SetEvent(_event);
}

//==============================================================
//		[XF
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetReleaseVoice(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 7) && (i >= 0) ){
		SetEvent(new mml_general(nsd_Release_Voice + (unsigned char)i, L"Release Voice"));
	} else {
		MML->Err(L"[XF0`7͈̔͂Ŏw肵ĂB");
	}
}

//==============================================================
//		[X
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetReleaseVolume(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 15) && (i >= 0) ){
		SetEvent(new mml_general(nsd_Release_Volume + (unsigned char)i, L"Release Volume"));
	} else {
		MML->Err(L"ʂ0`15͈̔͂Ŏw肵ĂB");
	}
}

//==============================================================
//		XC[v
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetSweep(MMLfile* MML)
{
				int		iSpeed;
				int		iDepth;
	unsigned	char	_data;
	unsigned	char	cData;

	iSpeed = MML->GetInt();

	cData = MML->GetChar();
	if(cData != ','){
		if( (iSpeed < 0) || (iSpeed > 255) ){
			MML->Err(L"sR}h0`255͈̔͂Ŏw肵ĂB");
		}
		MML->Back();
		_data = (unsigned char)iSpeed;
	} else {
		if( (iSpeed < 0) || (iSpeed > 15) ){
			MML->Err(L"sR}h̑1p[^0`15͈̔͂Ŏw肵ĂB");
		}
		iDepth = MML->GetInt();
		if( (iDepth < 0) || (iDepth > 15) ){
			MML->Err(L"sR}h̑2p[^0`15͈̔͂Ŏw肵ĂB");
		}
		_data = (unsigned char)(((iSpeed & 0x0F) << 4) | (iDepth & 0x0F));
	}

	SetEvent(new mml_general(nsd_Sweep, _data, L"Sweep"));
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetPoke(MMLfile* MML)
{
	unsigned	int	addr;
	unsigned	int	data;
	unsigned	char	cData;

	addr = MML->GetInt();
	if( (addr < 0x0000) || (addr > 0xFFFF) ){
		MML->Err(L"yR}h̃AhX$0000`$FFFF͈̔͂Ŏw肵ĉB");
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(L"yR}h̃p[^܂BQw肵ĂB");
	}

	data = MML->GetInt();
	if(data > 255){
		MML->Err(L"yR}h̃f[^$00`$FF͈̔͂Ŏw肵ĉB");
	}
	SetEvent(new mml_poke(addr, (unsigned char)data));
}

//==============================================================
//			FDS	LAgݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::Set_FDS_Frequency(MMLfile* MML)
{
	int	i = MML->GetInt();

	if( (i <= 0x0FFF) && (i >=0) ){
		unsigned	char	c0 = (unsigned char)( i       & 0xFF);
		unsigned	char	c1 = (unsigned char)((i >> 8) & 0xFF);
		SetEvent(new mml_general(nsd_FDS_Frequency,c0,c1,L"FDS career frequency"));
	} else {
		MML->Err(L"FDS̃LAg0`4095͈̔͂Ŏw肵ĉB");
	}
}

//==============================================================
//			FDS	Master volume
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::Set_FDS_Volume(MMLfile* MML)
{
	int		i = MML->GetInt();

	if((i<=3 ) && (i>=0)){
		SetEvent(new mml_general(nsd_FDS_Volume,(unsigned char)i,L"FDS Master volume"));
	} else {
		MML->Err(L"FDS̃}X^[ʂ0`3͈̔͂Ŏw肵ĉB");
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	TrackSet::SetVRC7_Write(MMLfile* MML)
{
	unsigned	char	cData;

				int		_Reg;
				int		_Dat;

	_Reg = MML->GetInt();
	if( (_Reg < 0) || (_Reg > 0x40) ){
		MML->Err(L"VRC7WX^̑1p[^0`63͈̔͂Ŏw肵ĂB");
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(L"P R}h̃p[^܂BSw肵ĂB");
	}

	_Dat = MML->GetInt();
	if( (_Dat < 0) || (_Dat > 255) ){
		MML->Err(L"VRC7WX^̑2p[^0`255͈̔͂Ŏw肵ĂB");
	}

	SetEvent(new mml_general(nsc_VRC7_reg,(unsigned char)_Reg,(unsigned char)_Dat, L"VRC7 Register Write"));
}

//==============================================================
//		NC	n163`lݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::SetN163Channel(MMLfile* MML)
{
	int	i = MML->GetInt();

	if( (i <= 8) && (i >=1) ){
		SetEvent(new mml_general(nsc_N163_Channel,(unsigned char)(i-1),L"n163 channel"));
	} else {
		MML->Err(L"n163̃`l1`8͈̔͂Ŏw肵ĂB");
	}

}

//==============================================================
//			SUNSOFT 5b Gx[vgݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::Set_FME7_Frequency(MMLfile* MML)
{
	int	i = MML->GetInt();

	if( (i <= 0xFFFF) && (i >=0) ){
		unsigned	char	c0 = (unsigned char)( i       & 0xFF);
		unsigned	char	c1 = (unsigned char)((i >> 8) & 0xFF);
		SetEvent(new mml_general(nsc_FME7_frequency,c0,c1,L"FME7 envelop frequency"));
	} else {
		MML->Err(L"SUNSOFT 5b̃n[hEFAGx[vg0`65535͈̔͂Ŏw肵ĉB");
	}
}

//==============================================================
//			ʉDxݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	TrackSet::SetPriority(MMLfile* MML)
{
	int	i = MML->GetInt();

	//se?
	if(fSE == false){
		MML->Warning(L"SEubNȊOł͗Dxw͂ł܂B܂B");
	} else {
		if( (i <= 3) && (i >=0) ){
			Priority = (char)i;
		} else {
			MML->Err(L"ʉ̗Dx́A0`3͈̔͂Ŏw肵ĉB");
		}
	}

}
